// Code generated by mockery v2.52.2. DO NOT EDIT.

package patch

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
)

// MockPatchUploader is an autogenerated mock type for the PatchUploader type
type MockPatchUploader struct {
	mock.Mock
}

type MockPatchUploader_Expecter struct {
	mock *mock.Mock
}

func (_m *MockPatchUploader) EXPECT() *MockPatchUploader_Expecter {
	return &MockPatchUploader_Expecter{mock: &_m.Mock}
}

// AddPatch provides a mock function with given fields: ctx, meta
func (_m *MockPatchUploader) AddPatch(ctx context.Context, meta *Metadata) error {
	ret := _m.Called(ctx, meta)

	if len(ret) == 0 {
		panic("no return value specified for AddPatch")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *Metadata) error); ok {
		r0 = rf(ctx, meta)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockPatchUploader_AddPatch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'AddPatch'
type MockPatchUploader_AddPatch_Call struct {
	*mock.Call
}

// AddPatch is a helper method to define mock.On call
//   - ctx context.Context
//   - meta *Metadata
func (_e *MockPatchUploader_Expecter) AddPatch(ctx interface{}, meta interface{}) *MockPatchUploader_AddPatch_Call {
	return &MockPatchUploader_AddPatch_Call{Call: _e.mock.On("AddPatch", ctx, meta)}
}

func (_c *MockPatchUploader_AddPatch_Call) Run(run func(ctx context.Context, meta *Metadata)) *MockPatchUploader_AddPatch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(*Metadata))
	})
	return _c
}

func (_c *MockPatchUploader_AddPatch_Call) Return(_a0 error) *MockPatchUploader_AddPatch_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockPatchUploader_AddPatch_Call) RunAndReturn(run func(context.Context, *Metadata) error) *MockPatchUploader_AddPatch_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockPatchUploader creates a new instance of MockPatchUploader. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPatchUploader(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPatchUploader {
	mock := &MockPatchUploader{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
